<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { watch, ref, onMounted, onUnmounted, computed } from 'vue';
import { SVG, Point } from '@svgdotjs/svg.js';
import { getElementPosition } from '@/lib/line';

const props = defineProps<{
    backgroundColor: string,
    color: string,
    size: number,
    dash?: boolean,
    ending: string,
    lineText: boolean,
    fontFamily?: string,
    curved?: boolean
}>();

const leftBox = ref<HTMLElement | null>(null);
const rightBox = ref<HTMLElement | null>(null);
const svgContainer = ref<HTMLDivElement | null>(null);

let draw: any;
let line: any;
let text: any;
let arrow: any;

const arrowSize = computed(() => props.size * (props.size === 1 ? 7 : 5));

const updateLine = () => {
    if (!leftBox.value || !rightBox.value || !line) return;
    const startRect = leftBox.value.getBoundingClientRect();
    const endRect = rightBox.value.getBoundingClientRect();
    const containerRect = svgContainer.value!.getBoundingClientRect();
    const startX = startRect.left - containerRect.left + startRect.width / 2;
    const startY = startRect.top - containerRect.top + startRect.height / 2;
    const endX = endRect.left - containerRect.left + endRect.width / 2;
    const endY = endRect.top - containerRect.top + endRect.height / 2;

    line.plot(startX, startY, endX, endY);

    if (text) {
        const midX = (startX + endX) / 2;
        const midY = (startY + endY) / 2;
        text.center(midX, midY);
    }

    if (arrow && props.ending !== 'none') {
        const endPoint = new Point(endX, endY);
        
        const beforeEndPoint = new Point(
            endX - (endX - startX) * (1 / Math.sqrt(Math.pow(endX - startX, 2) + Math.pow(endY - startY, 2))),
            endY - (endY - startY) * (1 / Math.sqrt(Math.pow(endX - startX, 2) + Math.pow(endY - startY, 2)))
        );

        const arrowAngle = Math.atan2(endPoint.y - beforeEndPoint.y, endPoint.x - beforeEndPoint.x);
        
        const arrowPath = `M ${endPoint.x} ${endPoint.y} L ${endPoint.x - arrowSize.value * Math.cos(arrowAngle - Math.PI / 6)} ${endPoint.y - arrowSize.value * Math.sin(arrowAngle - Math.PI / 6)} L ${endPoint.x - arrowSize.value * Math.cos(arrowAngle + Math.PI / 6)} ${endPoint.y - arrowSize.value * Math.sin(arrowAngle + Math.PI / 6)} Z`;
        arrow.plot(arrowPath).fill(props.color);
    }
};

const initializeSVG = () => {
    if (!svgContainer.value) return;

    draw = SVG().addTo(svgContainer.value).size('100%', '100%');

    line = draw.line(0, 0, 0, 0)
        .stroke({ color: props.color, width: props.size, dasharray: props.dash ? '10 5' : '' })
        .fill('none');

    if (props.ending === 'arrow') {
        arrow = draw.path().fill(props.color);
    }

    if (props.lineText) {
        text = draw.text("Text")
            .font({ family: props.fontFamily, size: 20 })
            .fill('white')
            .stroke({ color: props.color, width: 3 })
            .attr({
                'paint-order': 'stroke',
                'stroke-linecap': 'round',
                'stroke-linejoin': 'round'
            })
            .center(0, 0);
    }

    updateLine();
};

onMounted(() => {
    setTimeout(()=>{
        initializeSVG();
    },100);
    window.addEventListener('resize', updateLine);
});

watch(() => [props.color, props.size, props.dash, props.lineText, props.ending, props.fontFamily], () => {
    if (line) {
        line.stroke({ color: props.color, width: props.size, dasharray: props.dash ? '10 5' : '' });
    }
    if (text) {
        text.text(props.lineText ? "Text" : "")
        .font({family: props.fontFamily})
        .fill('white')
        .stroke({ color: props.color, width: 3 });
    }
    if (arrow) {
        if (props.ending === 'arrow') {
            arrow.show().fill(props.color);
        } else {
            arrow.hide();
        }
    } else if (props.ending === 'arrow') {
        arrow = draw.path().fill(props.color);
    }
    updateLine();
});

onUnmounted(() => {
    window.removeEventListener('resize', updateLine);
});
</script>

<template>
    <div class="w-full">
        <label>{{ $t("adjustPanel.preview") }}</label>
        <div class="w-full h-20 max-w-full px-4 py-8 flex flex-row justify-between relative"
            :style="{ background: backgroundColor }">
            <div class="h-full w-8" ref="leftBox" id="leftBox"></div>
            <div class="h-full w-8" ref="rightBox" id="rightBox"></div>
            <div ref="svgContainer" class="absolute inset-0 pointer-events-none" style="z-index: 10;"></div>
        </div>
    </div>
</template>